import pygame,sys
from util import*

class Animation(object):
	
	def __init__(self,sheetname,w,kind = 0,fps = 8):
		
		self.image_list = slice_sheet(w,w,sheetname,kind)
		self.frame = 0
		
		self.cycles = 0
		self.loops = 0
		self.is_playing = False
		self.fps = fps
		
		self.acctime = 0
		self.updatetime = 1000/self.fps
		self.stop_loop = -1
		self.is_ended = False
		self.max_cycles = len(self.image_list) * self.stop_loop
		
		
	def set_fps(self,fps):
		self.fps = fps
		self.updatetime = 1000/self.fps
		
	def play(self,loops = -1):
		
		self.is_ended = False
		self.stop_loop = loops
		self.is_playing = True
		self.max_cycles = len(self.image_list) * self.stop_loop
		
		if not self.is_playing:
			
			self.frame = 0
			self.acctime = 0
			self.cycles = 0
	
	def get_by_index(self,index):
		
		if index > len(self.image_list):
			index = 0
		
		return self.image_list[index]
		
		
		
	# alias
	start = play
	
	def show_last(self):
		self.frame = len(self.image_list) - 1		
	
	def stop(self):
	
		self.is_playing = False
		#self.frame = 0
		self.acctime = 0
			
	def update(self,timepassed):
		
		self.loops = (self.cycles)/len(self.image_list)	
		
		if self.is_playing:
				
			self.acctime += timepassed
			
			if self.acctime > self.updatetime:
				self.frame = (self.frame + 1) % len(self.image_list)
				self.cycles += 1
				self.acctime = 0
		
			
			if self.stop_loop > -1:
				if self.cycles >= (self.max_cycles-1):
					#print self.frame
					self.stop()
					self.is_ended = True
				
		
	def get_image(self):
		
		return self.image_list[self.frame]
		