from particle import*
import os.path as path
from cnst import*
 
class Gun(object):
	
	def __init__(self,parent,x,y):
		
		self.parent = parent
		self.x,self.y = (x,y)
		self.fire_updatetime = 200
		self.fire_acctime = 0
		self.angle = 0
		
		self.emitter = Emitter(path.join(IMGDIR,"pbullet.png"),8,self.x,self.y,friction = 1.01,
									fps=6,angle = self.angle, kind = 2,loop = -1,speed = 3)
		
		
	def update(self,timepassed):
		
		self.fire_acctime += timepassed
		
		self.emitter.x = self.x
		self.emitter.y = self.y
		self.emitter.angle = self.angle
		self.emitter.update(timepassed)
		
		for particle in self.emitter.particle_list:
			
			if particle.x < -10:
				particle.alive = False
			if particle.x > 340:
				particle.alive = False
			if particle.y < -10:
				particle.alive = False
			if particle.y > 260:
				particle.alive = False
			
		#print len(self.emitter.particle_list)
		
	def draw(self,surface):
		
		self.emitter.draw(surface)
		
	def fire(self):
		
		if self.fire_acctime > self.fire_updatetime:
			
			ax = math.cos(self.angle*(math.pi/180))
			ay = math.sin(self.angle*(math.pi/180))
			
			ax*= 1.2
			ay*= 1.2
			
			self.parent.xvel -= ax
			self.parent.yvel -= ay
			
			
			self.fire_acctime = 0
			self.emitter.burst(1)
			self.parent.game.game_sounds["fire"].play()
				
		
 