import pygame

def slice_sheet(w, h, filename, kind = 0):
	
	# kind : 0- normal image
	# kind : 1- alpha image
	# kind : 2- color keyed image  color used is magenta -(255,0,255)
	
	image_list=[]
	
	if kind == 0:
		master_image=pygame.image.load(filename).convert()
	
	elif kind == 1:
		master_image = pygame.image.load(filename).convert_alpha()
	
	elif kind == 2:
		master_image=pygame.image.load(filename).convert()
		master_image.set_colorkey((255,0,255))
	
	master_w,master_h = master_image.get_size()
	h = master_h
	
	for i in range(int(master_w/w)):
		image_list.append(master_image.subsurface(i*w,0,w,h))
	return image_list

def rotate_image(image,rect,angle):
	"""Rotate an image while keeping its center"""
	
	rot_image = pygame.transform.rotate(image,angle)
	rot_rect = rot_image.get_rect(center = rect.center)
	
	return (rot_image,rot_rect)
	
	
def fill_gradient(surface, color, gradient, rect=None, vertical=True, forward=True):
	"""Fills a surface with a gradient pattern"""
	
	# param : color - starting color
	# param : gradient - final color
	# param : vertical - True=vertical; False=horizontal
	
	if rect is None:
		rect = surface.get_rect()
		
	x1, x2 = rect.left, rect.right
	y1, y2 = rect.top, rect.bottom
	
	if vertical:
		h = y2 - y1
	else:
		h = x2 - x1
		
	if forward:
		a,b = color,gradient
	else:
		b,a = color,gradient
		
	rate = (
			float(b[0]-a[0])/h,
			float(b[1]-a[1])/h,
			float(b[2]-a[2])/h
			)
	
	fn_line = pygame.draw.line
	
	if vertical:
		for line in range(y1,y2):
			color = (
				min(max(a[0]+(rate[0]*(line-y1)),0),255),
				min(max(a[1]+(rate[1]*(line-y1)),0),255),
				min(max(a[2]+(rate[2]*(line-y1)),0),255)
			)
			fn_line(surface,color,(x1,line),(x2,line))
			
	else:
		for col in range(x1,x2):
			color = (
				min(max(a[0]+(rate[0]*(col-x1)),0),255),
				min(max(a[1]+(rate[1]*(col-x1)),0),255),
				min(max(a[2]+(rate[2]*(col-x1)),0),255)
			)
			fn_line(surface,color,(col,y1),(col,y2))
		